unit UAdvEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TAdvEdit = class(TEdit)
  private
    FUpPress: TNotifyEvent;
    FDownPress: TNotifyEvent;
    FEndPress: TNotifyEvent;
    FHomePress: TNotifyEvent;
    FPgDnPress: TNotifyEvent;
    FPgUpPress: TNotifyEvent;
    FEscPress: TNotifyEvent;
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KeyDown;
  public


  published
    property OnUpPress: TNotifyEvent read FUpPress write FUpPress;
    property OnDownPress: TNotifyEvent read FDownPress write FDownPress;
    property OnHomePress: TNotifyEvent read FHomePress write FHomePress;
    property OnEndPress: TNotifyEvent read FEndPress write FEndPress;
    property OnPgDnPress: TNotifyEvent read FPgDnPress write FPgDnPress;
    property OnPgUpPress: TNotifyEvent read FPgUpPress write FPgUpPress;
    property OnEscapePress: TNotifyEvent read FEscPress write FEscPress;
  end;

procedure Register;

implementation

procedure TAdvEdit.WMKeyDown(var Message: TWMKeyDown);
begin
  with Message do
  begin
    if Perform(CM_CHILDKEY, CharCode, Integer(Self)) <> 0 then Exit;
    case CharCode of
        VK_UP: if Assigned(OnUpPress) then OnUpPress(Self)
                else  Inherited;
        VK_DOWN: if Assigned(OnDownPress) then OnDownPress(Self)
                else  Inherited;
        VK_END: if Assigned(OnEndPress) then OnEndPress(Self)
                else  Inherited;
        VK_HOME: if Assigned(OnHomePress) then OnHomePress(Self)
                else  Inherited;
        VK_ESCAPE: if Assigned(OnEscapePress) then OnEscapePress(Self)
                else  Inherited;
        VK_NEXT: if Assigned(OnPgDnPress) then OnPgDnPress(Self)
                else  Inherited;
        VK_PRIOR: if Assigned(OnPgUpPress) then OnPgUpPress(Self)
                else  Inherited;
        else  Inherited;
    end;
  end;
end;

procedure Register;
begin
  RegisterComponents('Alien', [TAdvEdit]);
end;

end.
